// ----------------- подключаем Wi-Fi и Telegram
#ifdef ESP32
#include <WiFi.h>
#else
#include <ESP8266WiFi.h>
#endif
#include <WiFiClientSecure.h>
#include <UniversalTelegramBot.h>

// ------------------ активируем датчик температуры
#ifdef __cplusplus
extern "C" {
#endif
uint8_t temprature_sens_read();
#ifdef __cplusplus
}
#endif
uint8_t temprature_sens_read();

// ------------------------------------- информация о Wi-Fi сети и боте
const char* ssid = "HUAWEI-DrProg_2G";
const char* password = "2311197600";
#define BOTtoken "5274275654:AAGxY4UM7Y3H6hUCBEgOANGK-sZTU1Ks3Vk"

// ------------------------------------- подключаем светодиодную ленту
#include <Adafruit_NeoPixel.h>
#ifdef __AVR__
#include <avr/power.h> // Required for 16 MHz Adafruit Trinket
#endif
#ifdef ESP8266
X509List cert(TELEGRAM_CERTIFICATE_ROOT);
#endif

// -------------------------------------- запускаем то и другое
WiFiClientSecure client;
UniversalTelegramBot bot(BOTtoken, client);
#define PIN        4  // пин ленты
#define NUMPIXELS 124 // количество пикселей в кольцах
Adafruit_NeoPixel pixels(NUMPIXELS, PIN, NEO_GRB + NEO_KHZ800);

//byte ledRej = 0;      // режим работы

void lenta( void *pvParameters );  // установка цвета на ленте
byte newColor = 0;                 // флаг нового цвета
byte rgb[3] = {0, 0, 10};          // новый цвет
byte rgb_old[3] = {0, 0, 10};      // старый цвет

// эадержки для разных видов анимации
#define del 30
#define delsr 500


// ----------------- анимация переходов для функции cep() змейка и колесо в разные стороны
byte zmey1[8][3] = {
  0, 32, 0,
  83, 74, 1,
  84, 94, 0,
  124, 107, 1,
  94, 108, 0,
  74, 59, 1,
  32, 60, 0,
  0, 0, 2
};

byte col1[5][3] = {
  0, 60, 0,
  60, 83, 0,
  83, 107, 0,
  106, 124, 0,
  0, 0, 2
};

byte col2[5][3] = {
  59, 0, 0,
  83, 59, 0,
  107, 82, 0,
  123, 107, 0,
  0, 0, 2
};

byte zmey2[8][3] = {
  0, 32, 0,
  83, 74, 1,
  84, 94, 0,
  124, 107, 1,
  94, 108, 0,
  74, 59, 1,
  32, 60, 0,
  0, 0, 2
};


void setup() {
  pixels.begin(); // запускаем и обнуляем ленту
  pixels.clear();
  rnd(10, 0, 0);  // устанавливаем красный цвет (ожидание связи)
  xTaskCreateUniversal(lenta, "lenta", 4096, NULL, 4, NULL, 1);  // запускаем поток для ленты на ядре 1 (все остальное работает на ядре 0)


#ifdef ESP8266
  configTime(0, 0, "pool.ntp.org");
  client.setTrustAnchors(&cert);
#endif

  // ----------------------------- Соединяемся в Wi-Fi
  WiFi.mode(WIFI_STA);
  WiFi.begin(ssid, password);
#ifdef ESP32
  client.setCACert(TELEGRAM_CERTIFICATE_ROOT);
#endif
  while (WiFi.status() != WL_CONNECTED) {
    delay(1000);
    Serial.println("Connecting to WiFi..");
  }

  Serial.println(WiFi.localIP());
  Serial.begin(9600);
  randomSeed(analogRead(0));
  rnd(0, 10, 0);  // есть соединение, выставляем зеленый цвет на ленте
}

void loop() {
  scan_msg();     // сканируем приходящие сообщения
}



void scan_msg() { // сканируем приходящие сообщения
  static unsigned long timer;
  if (millis() > timer + 1000)  {         // опрашиваем раз в секунду, чаще нет смысле
    int numNewMessages = bot.getUpdates(bot.last_message_received + 1);
    while (numNewMessages) {
      Serial.println("получено сообщение");     // есть сообщение
      handleNewMessages(numNewMessages);  // отправляем его на обработку
      numNewMessages = bot.getUpdates(bot.last_message_received + 1);
    }
    timer = millis();
  }
}

void handleNewMessages(int numNewMessages) { //
  Serial.println("handleNewMessages");
  Serial.println(String(numNewMessages));
  for (int i = 0; i < numNewMessages; i++) {
    String chat_id = String(bot.messages[i].chat_id);  // запоминаем id собеседника для ответа
    String text = bot.messages[i].text;                // извлекаем текст сообщения
    Serial.println(text);
    String from_name = bot.messages[i].from_name;      // имя собеседника, для веливого обращения
    if (text == "/start") {                            // ответ на стандартную первую команду "/start", перечисляем доступные команды
      Serial.println("стартовое сообщение");
      String welcome = "Привет, " + from_name + ".\n";
      welcome += "Можно использовать следующие команды:\n\n";
      welcome += "/n RRR,GGG,BBB чтобы установить новый цвет, где RGB цвета от 0 до 255 \n";
      welcome += "/c чтобы узнать какой сейчас цвет\n";
      welcome += "/t чтобы узнать температуру чипа \n";
      bot.sendMessage(chat_id, welcome, "");
    }

    String command = text.substring(0, 2);
    Serial.print("получена команда: ");
    Serial.println(command);

    if (command == "/c") {
      String col = "сейчас установлен цвет RGB: " + String(rgb[0]) + ", " + String(rgb[1]) + ", " + String(rgb[2]) + " \n";
      bot.sendMessage(chat_id, col, "");
    }

    if (command == "/n") { // если пришла команда сменить цвет, парсим строку выискивая три заданные цвета
      String acol;
      byte s[2];
      s[0] = text.indexOf(",");
      s[1] = text.indexOf(",", s[0] + 1);
      acol = text.substring(2, s[0]);
      rgb[0] = constrain((acol.toInt() / 3), 0, 80); // делим значения на три, чтобы не перегрузить ленту
      acol = text.substring(s[0] + 1, s[1]);
      rgb[1] = constrain((acol.toInt() / 3), 0, 80);
      acol = text.substring(s[1] + 1, text.length());
      rgb[2] = constrain((acol.toInt() / 3), 0, 80);

      bot.sendMessage(chat_id, "новый цвет установлен!", ""); // подтверждаем выполнение команды
      String col = "сейчас установлен цвет RGB: " + String(rgb[0]) + ", " + String(rgb[1]) + ", " + String(rgb[2]);
      newColor = 1;
      Serial.println(col);
      delay(4000);          // минимальная задержка до следующей смены увета
    }

    if (text == "/t") {     // отвечаем на запрос температуры чипа
      int t = (temprature_sens_read() - 32) / 1.8;
      String msg = "температура чипа: " + String((temprature_sens_read() - 32) / 1.8);
      bot.sendMessage(chat_id, msg, "");
    }

  }
}

void lenta( void *pvParameters ) {
  byte effect;
  while (1) {
    if (newColor) {
      effect = random(9);  // случайным образом выбираем один из девяти анимаций смены цвета и выполняем ее
      //effect = 8;
      Serial.print("эффект ");
      Serial.println(effect);
      switch (effect) {
        case 0:
          cep(rgb[0], rgb[1], rgb[2], zmey1, 0);
          break;
        case 1:
          cep(rgb[0], rgb[1], rgb[2], zmey2, 0);
          break;
        case 2:
          rnd(rgb[0], rgb[1], rgb[2]);
          break;
        case 3:
          cep(rgb[0], rgb[1], rgb[2], col1, 0);
          break;
        case 4:
          cep(rgb[0], rgb[1], rgb[2], col2, 0);
          break;
        case 5:
          cep(rgb[0], rgb[1], rgb[2], col1, 1);
          break;
        case 6:
          cep(rgb[0], rgb[1], rgb[2], col2, 1);
          break;
        case 7:
          theaterChase(rgb[0], rgb[1], rgb[2]);
          break;
        case 8:
          fade();
          break;
      }
      for (byte i = 0; i < 3; i++) {
        rgb_old[i] = rgb[i];
      }
      newColor = 0;
    }
    delay(1000);
  }
}


// ------------------ функции анимации смены цвета (можно дополнить)

void rnd(byte r, byte g, byte b) {  // колесо
  byte rndd[125];
  for (byte i = 0; i < 125; i++) rndd[i] = 0;
  byte a;
  byte bb = 0;
  for (byte i = 0; i < 125; i++) {
    while (!bb) {
      a = random(125);
      if (!rndd[a]) {
        rndd[a] = 1;
        bb = 1;
      }
    }
    bb = 0;
    //    Serial.println(a);
    pixels.setPixelColor(a, pixels.Color(r, g, b));
    pixels.show();
    delay(del);
  }
}

void cep(byte r, byte g, byte b, byte p[][3], byte sr) { // последовательная замена цвета пикселей, порядок устанавливается в массиве p[][]
  byte ii = 0;
  byte n;
  //  Serial.println(p[3][1]);
  while (p[ii][2] < 2) {
    n = p[ii][0] > p[ii][1];
    for (byte i = p[ii][0]; i != p[ii][1]; i = n ? i - 1 : i + 1) { //i = p[ii][2] ? i - 1 : i + 1) {
      pixels.setPixelColor(i, pixels.Color(r, g, b));
      if (!sr) {
        pixels.show();
        delay(del);
      }
    }
    if (sr) {
      pixels.show();
      delay(delsr);
    }
    ii++;
  }
}

void theaterChase(byte r, byte g, byte b) {       // вращение
  for (int j = 0; j < 20; j++) {
    for (int q = 0; q < 3; q++) {
      for (uint16_t i = 0; i < pixels.numPixels(); i = i + 3) {
        pixels.setPixelColor(i + q, pixels.Color(r, g, b));
      }
      pixels.show();
      delay(del * 2);
      for (uint16_t i = 0; i < pixels.numPixels(); i = i + 3) {
        pixels.setPixelColor(i + q, 0);  
      }
    }
  }
  for (byte i = 0; i < 125; i++) pixels.setPixelColor(i, pixels.Color(r, g, b));
  pixels.show();
}

void fade() {     // плавный переход из старого цвета в новый
  float diff[3];
  float tempF[3];
  byte temp[3];
  for (byte ii = 0; ii < 3; ii++) {
    diff[ii] = float(rgb[ii] - rgb_old[ii]) / 50;
    tempF[ii] = float(rgb_old[ii]);
  }
  for (byte i = 0; i < 50; i++) {
    for (byte ii = 0; ii < 3; ii++ ) {
      tempF[ii] = tempF[ii] + diff[ii];
      temp[ii] = byte(tempF[ii]);
    }
    for (byte iii = 0; iii < 125; iii++) {
      pixels.setPixelColor(iii, temp[0], temp[1], temp[2]);
    }
    pixels.show();
    delay(50);
  }
}
